import { AbstractControl, AsyncValidatorFn, FormControl, FormGroup, ValidatorFn, FormBuilder } from '@angular/forms';

export interface FieldConfig {
  value?: any;
  validations?: { [key: string]: any };
  asyncValidations?: { [key: string]: any };
  errorMessages?: { [error: string]: string };
  enabled?: boolean;
  customValidation?: ValidatorFn;
  asyncCustomValidation?: AsyncValidatorFn;
  requiredIf?: { condition: () => boolean };
}

export declare class FormServiceDynamic {
  constructor(formBuilder: FormBuilder);

  createForm<T extends Record<string, any>>(
    model: T,
    options?: { [field: string]: FieldConfig }
  ): FormGroup;

  private createControl(value: any, config: FieldConfig): FormControl;

  private conditionallyRequiredValidator(config: FieldConfig): ValidatorFn;

  private isConditionallyRequired(config: FieldConfig): boolean;

  private normalizeValidations(validations: { [key: string]: any } | undefined): ValidatorFn | null;

  private normalizeAsyncValidations(asyncValidations: { [key: string]: any } | undefined): AsyncValidatorFn | null;
}
